#ifndef EXP_PORT_MGR_H
#define EXP_PORT_MGR_H

/*
 * $Id: ExpPortMgr.h,v 1.1.1.1 1999/01/27 08:40:45 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Ring.h"
#include "PortMgr.h"


// fifo pool of ports, explicit mapping with bind
class ExpPortMgr: public PortMgr {
	public:
		ExpPortMgr();
		ExpPortMgr(int aPortMin, int aPortMax);

		void configure(int aPortMin, int aPortMax);

	protected:

		virtual int allocPort(Socket &s);
		virtual void freePort(int port, bool good);

		int findPort(Ring<int> &ports, Socket &s);

	protected:
		Ring<int> theValidPorts; // never- or successfully-used ports
		Ring<int> theVoidPorts;  // last-use-failed ports
		int thePortMin;
		int thePortMax;
};

#endif
