#ifndef X_NET_DOUBLE_H
#define X_NET_DOUBLE_H

/*
 * $Id: NetDouble.h,v 1.1.1.4 1999/03/08 07:50:34 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/* BSD hton */
#include <sys/param.h>

/* IRIX hton */
#include <sys/types.h>
#include <netinet/in.h>

/* Solaris hton */
#include <arpa/inet.h>


// binary, fpoint-representation-independent storage for doubles
class NetDouble {
	public:
		NetDouble(): mnt(0), exp(0) {}
		NetDouble(double x);     // extracts components 

		operator double() const; // merges components

		inline bool operator ==(const NetDouble &d);
		inline bool operator !=(const NetDouble &d);

	public:
		int mnt; // mantissa
		int exp; // exponent
};

inline
bool NetDouble::operator ==(const NetDouble &d) {
	return mnt == d.mnt && exp == d.exp;
}

inline
bool NetDouble::operator !=(const NetDouble &d) {
	return mnt != d.mnt || exp != d.exp;
}

#endif
